$(function() {
var form = $("#form").dxForm({
colCount: 2,
formData: employee,
items: [
{
itemType: "group",
items: [
{
itemType: "group",
caption: "Personal Data",
items: ["FirstName", "LastName", {
itemType: "simple",
editorType: "dxCheckBox",
editorOptions: {
text: "Show Address",
value: true,
onValueChanged: function(e) {
form.itemOption("HomeAddress", "visible", e.value);
}
}
}]
},
{
itemType: "group",
items: [{
itemType: "group",
name: "HomeAddress",
caption: "Home Address",
items: ["Address", "City"]
}]
}
]
},
{
itemType: "group",
caption: "Phones",
name: "phones-container",
items: [
{
itemType: "group",
name: "phones",
items: getPhonesOptions(employee.Phones)
},
{
itemType: "button",
horizontalAlignment: "left",
cssClass: "add-phone-button",
buttonOptions: {
icon: "add",
text: "Add phone",
onClick: function() {
employee.Phones.push("");
form.itemOption("phones-container.phones", "items", getPhonesOptions(employee.Phones));
}
}
}
]
}
]
}).dxForm("instance");
function getPhonesOptions(phones) {
var options = [];
for (var i = 0; i < phones.length; i++){
options.push(generateNewPhoneOptions(i));
}
return options;
}
function generateNewPhoneOptions(index) {
return {
dataField: "Phones[" + index + "]",
editorType: "dxTextBox",
cssClass: "phone-editor",
label: {
text: "Phone "+(index + 1)
},
editorOptions: {
mask: "+1 (X00) 000-0000",
maskRules: {"X": /[01-9]/},
buttons: [{
name: "trash",
location: "after",
options: {
stylingMode: "text",
icon: "trash",
onClick: function() {
employee.Phones.splice(index, 1);
form.itemOption("phones-container.phones", "items", getPhonesOptions(employee.Phones));
}
}
}]
}
}
}
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/20.2.5/js/dx.all.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="long-title"><h3>Personal details</h3></div>
<div id="form-container">
<div id="form"></div>
</div>
</div>
</body>
</html>
#form-container {
margin: 10px 10px 30px;
}
.long-title h3 {
font-family: 'Segoe UI Light', 'Helvetica Neue Light', 'Segoe UI', 'Helvetica Neue', 'Trebuchet MS', Verdana;
font-weight: 200;
font-size: 28px;
text-align: center;
margin-bottom: 20px;
}
.add-phone-button {
margin-top: 10px;
}
var employee = {
"FirstName": "John",
"LastName": "Heart",
"Address": "351 S Hill St., Los Angeles, CA",
"City": 'Atlanta',
"Phones": ["8005552797", "8005953232"]
};

import React from 'react';
import 'devextreme-react/text-area';
import Form, { GroupItem, SimpleItem, Label } from 'devextreme-react/form';
import service from './data.js';
class App extends React.Component {
constructor(props) {
super(props);
this.employee = service.getEmployee();
this.checkBoxOptions = {
text: 'Show Address',
value: true,
onValueChanged: (e) => {
this.setState({
isHomeAddressVisible: e.component.option('value'),
});
},
};
this.addPhoneButtonOptions = {
icon: 'add',
text: 'Add phone',
onClick: () => {
this.employee.Phones.push('');
this.updatePhones();
},
};
this.state = {
phoneOptions: this.getPhonesOptions(),
isHomeAddressVisible: true,
};
this.generateNewPhoneOptions = this.generateNewPhoneOptions.bind(this);
this.getPhonesOptions = this.getPhonesOptions.bind(this);
this.updatePhones = this.updatePhones.bind(this);
}
render() {
return (
<React.Fragment>
<div className="long-title"><h3>Personal details</h3></div>
<div className="form-container">
<Form
colCount={2}
id="form"
formData={this.employee}>
<GroupItem>
<GroupItem>
<GroupItem caption="Personal Data">
<SimpleItem dataField="FirstName" />
<SimpleItem dataField="LastName" />
<SimpleItem editorType="dxCheckBox" editorOptions={this.checkBoxOptions} />
</GroupItem>
</GroupItem>
<GroupItem>
<GroupItem caption="Home Address"
name="HomeAddress"
visible={this.state.isHomeAddressVisible}>
<SimpleItem dataField="Address" />
<SimpleItem dataField="City" />
</GroupItem>
</GroupItem>
</GroupItem>
<GroupItem caption="Phones"
name="phones-container">
<GroupItem
name="phones">
{ this.state.phoneOptions.map((phone, index) => <SimpleItem
key = {`Phones${index}`}
dataField={`Phones[${index}]`}
editorOptions={phone}>
<Label text={`Phone ${index + 1}`} />
</SimpleItem>)}
</GroupItem>
<SimpleItem itemType="button"
horizontalAlignment="left"
cssClass="add-phone-button"
buttonOptions={this.addPhoneButtonOptions}>
</SimpleItem>
</GroupItem>
</Form>
</div>
</React.Fragment>
);
}
getPhonesOptions() {
const options = [];
for (let i = 0; i < this.employee.Phones.length; i += 1) {
options.push(this.generateNewPhoneOptions(i));
}
return options;
}
generateNewPhoneOptions(index) {
return {
mask: '+1 (X00) 000-0000',
maskRules: { X: /[01-9]/ },
buttons: [{
name: 'trash',
location: 'after',
options: {
stylingMode: 'text',
icon: 'trash',
onClick: () => {
this.employee.Phones.splice(index, 1);
this.updatePhones();
},
},
}],
};
}
updatePhones() {
this.setState({
phoneOptions: this.getPhonesOptions(),
});
}
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.form-container {
margin: 10px 10px 30px;
}
.long-title h3 {
font-family: 'Segoe UI Light', 'Helvetica Neue Light', 'Segoe UI', 'Helvetica Neue', 'Trebuchet MS', Verdana;
font-weight: 200;
font-size: 28px;
text-align: center;
margin-bottom: 20px;
}
.add-phone-button {
margin-top: 10px;
}
const employee = {
FirstName: 'John',
LastName: 'Heart',
Address: '351 S Hill St., Los Angeles, CA',
City: 'Atlanta',
Phones: ['8005552797', '8005953232'],
};
export default {
getEmployee() {
return employee;
},
};
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.1.4/cjs',
'devextreme-react': 'npm:devextreme-react@22.1.4',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.16/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.63/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.32/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.7',
'inferno': 'npm:inferno@7.4.4/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.7/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);

<div class="long-title">
<h3>Personal details</h3>
</div>
<div id="form-container">
<dx-form id="form" [colCount]="2" [formData]="employee">
<dxi-item itemType="group">
<dxi-item itemType="group" caption="Personal Data">
<dxi-item dataField="FirstName"></dxi-item>
<dxi-item dataField="LastName"></dxi-item>
<dxi-item
editorType="dxCheckBox"
[editorOptions]="checkBoxOptions"
></dxi-item>
</dxi-item>
<dxi-item itemType="group">
<dxi-item
itemType="group"
caption="Home Address"
name="HomeAddress"
[visible]="isHomeAddressVisible"
>
<dxi-item dataField="Address"></dxi-item>
<dxi-item dataField="City"></dxi-item>
</dxi-item>
</dxi-item>
</dxi-item>
<dxi-item itemType="group" caption="Phones" name="phones-container">
<dxi-item
itemType="group"
name="phones"
*ngFor="let phone of phoneOptions; let i = index"
>
<dxi-item
[dataField]="'Phones[' + i + ']'"
[editorOptions]="phoneOptions[i]"
>
<dxo-label [text]="'Phone ' + (i + 1)"> </dxo-label>
</dxi-item>
</dxi-item>
<dxi-item
itemType="button"
horizontalAlignment="left"
cssClass="add-phone-button"
[buttonOptions]="addPhoneButtonOptions"
>
</dxi-item>
</dxi-item>
</dx-form>
</div>
import {
NgModule, Component, enableProdMode, AfterViewInit,
} from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import {
DxFormModule,
} from 'devextreme-angular';
import { Employee, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
})
export class AppComponent implements AfterViewInit {
employee: Employee;
isHomeAddressVisible: boolean;
checkBoxOptions: any;
phoneOptions: any[] = [];
addPhoneButtonOptions: any;
constructor(service: Service) {
this.employee = service.getEmployee();
this.isHomeAddressVisible = true;
this.phoneOptions = this.getPhonesOptions(this.employee.Phones);
this.checkBoxOptions = {
text: 'Show Address',
value: true,
onValueChanged: (e) => {
this.isHomeAddressVisible = e.component.option('value');
},
};
this.addPhoneButtonOptions = {
icon: 'add',
text: 'Add phone',
onClick: () => {
this.employee.Phones.push('');
this.phoneOptions = this.getPhonesOptions(this.employee.Phones);
},
};
}
ngAfterViewInit(): void {}
getPhonesOptions(phones: any) {
const options = [];
for (let i = 0; i < phones.length; i++) {
options.push(this.generateNewPhoneOptions(i));
}
return options;
}
generateNewPhoneOptions(index: number) {
return {
mask: '+1 (X00) 000-0000',
maskRules: { X: /[01-9]/ },
buttons: [{
name: 'trash',
location: 'after',
options: {
stylingMode: 'text',
icon: 'trash',
onClick: () => {
this.employee.Phones.splice(index, 1);
this.phoneOptions = this.getPhonesOptions(this.employee.Phones);
},
},
}],
};
}
}
@NgModule({
imports: [
BrowserModule,
DxFormModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #form-container {
margin: 10px 10px 30px;
}
::ng-deep .long-title h3 {
font-family: 'Segoe UI Light', 'Helvetica Neue Light', 'Segoe UI', 'Helvetica Neue', 'Trebuchet MS', Verdana;
font-weight: 200;
font-size: 28px;
text-align: center;
margin-bottom: 20px;
}
::ng-deep .add-phone-button {
margin-top: 10px;
}
import { Injectable } from '@angular/core';
export class Employee {
FirstName: string;
LastName: string;
Address: string;
City: string;
Phones: string[];
}
const employee : Employee = {
FirstName: 'John',
LastName: 'Heart',
Address: '351 S Hill St., Los Angeles, CA',
City: 'Atlanta',
Phones: ['8005552797', '8005953232'],
};
@Injectable()
export class Service {
getEmployee() : Employee {
return employee;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'@angular/core': 'npm:@angular/core@12.2.16',
'@angular/platform-browser': 'npm:@angular/platform-browser@12.2.16',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.16',
'@angular/forms': 'npm:@angular/forms@12.2.16',
'@angular/common': 'npm:@angular/common@12.2.16',
'@angular/compiler': 'npm:@angular/compiler@12.2.16',
'tslib': 'npm:tslib@2.3.1/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.1.4/cjs',
'devextreme/bundles/dx.all': 'npm:devextreme@22.1.4/bundles/dx.all.js',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.16/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.63',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.32',
'devextreme-angular': 'npm:devextreme-angular@22.1.4',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.7',
'inferno': 'npm:inferno@7.4.4/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.7/inferno/package.json',
'npm:@angular/*/package.json',
'npm:@angular/common@12.2.16/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devextreme-angular@22.1.4/*/package.json',
'npm:devextreme-angular@22.1.4/ui/*/package.json',
'npm:devextreme-angular@22.1.4/package.json',
'npm:devexpress-diagram@2.1.63/package.json',
'npm:devexpress-gantt@4.1.32/package.json',
],
};
System.config(window.config);
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.4/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.11.4/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.3/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

<template>
<div>
<div class="long-title"><h3>Personal details</h3></div>
<div id="form-container">
<DxForm
id="form"
:col-count="2"
:form-data="employee"
>
<DxGroupItem>
<DxGroupItem caption="Personal Data">
<DxSimpleItem data-field="FirstName"/>
<DxSimpleItem data-field="LastName"/>
<DxSimpleItem
:editor-options="checkBoxOptions"
editor-type="dxCheckBox"
/>
</DxGroupItem>
<DxGroupItem>
<DxGroupItem
:visible="isHomeAddressVisible"
caption="Home Address"
name="HomeAddress"
>
<DxSimpleItem data-field="Address"/>
<DxSimpleItem data-field="City"/>
</DxGroupItem>
</DxGroupItem>
</DxGroupItem>
<DxGroupItem
caption="Phones"
name="phones-container"
>
<DxGroupItem
item-type="group"
name="phones"
>
<DxSimpleItem
v-for="(phone, index) in phoneOptions"
:key="'Phone' + (index + 1)"
:data-field="'Phones[' + index + ']'"
:editor-options="phone"
>
<DxLabel :text="'Phone ' + (index + 1)"/>
</DxSimpleItem>
</DxGroupItem>
<DxButtonItem
:button-options="addPhoneButtonOptions"
css-class="add-phone-button"
horizontal-alignment="left"
/>
</DxGroupItem>
</DxForm>
</div>
</div>
</template>
<script>
import {
DxForm,
DxSimpleItem,
DxGroupItem,
DxButtonItem,
DxLabel,
} from 'devextreme-vue/form';
import service from './data.js';
export default {
components: {
DxForm,
DxSimpleItem,
DxGroupItem,
DxButtonItem,
DxLabel,
},
data() {
const employee = service.getEmployee();
const isHomeAddressVisible = true;
const phoneOptions = this.getPhonesOptions(employee.Phones);
return {
employee,
isHomeAddressVisible,
phoneOptions,
checkBoxOptions: {
text: 'Show Address',
value: true,
onValueChanged: (e) => {
this.isHomeAddressVisible = e.component.option('value');
},
},
addPhoneButtonOptions: {
icon: 'add',
text: 'Add phone',
onClick: () => {
this.employee.Phones.push('');
this.phoneOptions = this.getPhonesOptions(this.employee.Phones);
},
},
};
},
methods: {
getPhonesOptions(phones) {
const options = [];
for (let i = 0; i < phones.length; i += 1) {
options.push(this.generateNewPhoneOptions(i));
}
return options;
},
generateNewPhoneOptions(index) {
return {
mask: '+1 (X00) 000-0000',
maskRules: { X: /[01-9]/ },
buttons: [{
name: 'trash',
location: 'after',
options: {
stylingMode: 'text',
icon: 'trash',
onClick: () => {
this.employee.Phones.splice(index, 1);
this.phoneOptions = this.getPhonesOptions(this.employee.Phones);
},
},
}],
};
},
},
};
</script>
<style scoped>
#form-container {
margin: 10px 10px 30px;
}
.long-title h3 {
font-family:
'Segoe UI Light',
'Helvetica Neue Light',
'Segoe UI',
'Helvetica Neue',
'Trebuchet MS',
Verdana;
font-weight: 200;
font-size: 28px;
text-align: center;
margin-bottom: 20px;
}
.add-phone-button {
margin-top: 10px;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.5/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
const employee = {
FirstName: 'John',
LastName: 'Heart',
Address: '351 S Hill St., Los Angeles, CA',
City: 'Atlanta',
Phones: ['8005552797', '8005953232'],
};
export default {
getEmployee() {
return employee;
},
};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'vue': 'npm:vue@3.2.47/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.5/cjs',
'devextreme-vue': 'npm:devextreme-vue@22.2.5',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.20/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.72/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.42/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);